"""
Name:
CSE 160
Summer 2022
Final Exam
Collaboration:
"""

import math


# Problem 1
def common_artists(artists):
    """
    Calculates and returns number of artists shared across all sets
    divided by total number of unique artists shared among all sets
    in list of sets artists

    Arguments:
      artists (list): List of sets representing musical artist names

    Returns:
      Float representing fraction of common artists shared among sets,
      or 0.0 if there is at least one empty set in artists
    """


def test_common_artists():
    assert math.isclose(common_artists([{"BTS", "Hozier"},
                                        {"BTS", "Taylor Swift"},
                                        {"BTS", "Stray Kids"}]), 0.25)
    assert math.isclose(common_artists([{"(G)I-DLE"}]), 1.0)
    assert math.isclose(common_artists([{"IU"}, set()]), 0.0)


# Problem 2
def explore_seattle(seattle_map, curr_location):
    """
    Calculate distance between all Seattle locations in map and current
    location and return a new sorted list of the Seattle locations.

    Arguments:
      seattle_map (list): List of tuples representing Seattle location
        names and its x-y coordinates
      curr_location (tuple): x-y coordinate of current location

    Returns:
      List of Seattle location names sorted by distance to curr_location
      in ascending order, with ties in distance broken by alphabetical
      order of location names
    """


def test_explore_seattle():
    assert explore_seattle([("Suzzallo Library", (1, 1)),
                            ("Paul G. Allen School", (3, 5))], (7, 4)) == \
        ["Paul G. Allen School", "Suzzallo Library"]
    assert explore_seattle([("Snowy Village", (10, 0)),
                            ("Tea Republik", (0, 0))], (3, 4)) == \
        ["Tea Republik", "Snowy Village"]
    assert explore_seattle([("Henry Art Gallery", (1, 0)),
                            ("Museum of Museums", (0, 1)),
                            ("Seattle Art Museum", (-1, 0))], (0, 0)) == \
        ["Henry Art Gallery", "Museum of Museums", "Seattle Art Museum"]


# Problem 3
def find_optimal_kitten(kittens, kitten_preference, dealbreaker):
    """
    Calculates similarity score between attributes of your kitten_preference
    and other kittens (rowdiness, hungriness, cuddliness, loudness) and
    returns the most similar kitten to your preferences

    Arguments:
      kittens (dictionary): Dictionary with string of kitten names as keys,
        dictionary of preferences as values
      kitten_preference (dictionary): Dictionary with adopter preferences
        as keys, numerical scores as values
      dealbreaker (string or None): Adopter preference

    Returns:
      Name of kitten that has similarity score that is closest to your
      kitten_preference, or None if no kittens have been considered
    """


def test_find_optimal_kitten():
    kittens = {"blair": {"rowdiness": 100, "hungriness": 100,
                         "cuddliness": 0, "loudness": 27},
               "danli": {"rowdiness": 22, "hungriness": 40,
                         "cuddliness": 87, "loudness": 45},
               "jasper": {"rowdiness": 9, "hungriness": 70,
                          "cuddliness": 66, "loudness": 7},
               "orlando": {"rowdiness": 4, "hungriness": 34,
                           "cuddliness": 98, "loudness": 2},
               "gabrielle": {"rowdiness": 24, "hungriness": 30,
                             "cuddliness": 76, "loudness": 100}}

    kitten_preference = {"rowdiness": 70, "hungriness": 50,
                         "cuddliness": 100, "loudness": 10}

    assert find_optimal_kitten(kittens, kitten_preference, None) == "danli"
    assert find_optimal_kitten(kittens, kitten_preference,
                               "loudness") == "orlando"
    print("hi")
    assert find_optimal_kitten(kittens, kitten_preference, "rowdiness") is None


def main():
    test_common_artists()
    test_explore_seattle()
    test_find_optimal_kitten()


if __name__ == "__main__":
    main()
